//
//  MyDrawNode.cpp
//  box
//
//  Created by Reza Ghobadinic on 2018-10-21.
//

#include "MyDrawNode.hpp"


Node* MyDrawNode::createNode()
{
    return MyDrawNode::create();
}


bool MyDrawNode::init()
{
    if(!Node::init())
        return false;
    
    isDrawn = false;
    
    auto visibleSize = Director::getInstance()->getVisibleSize();
    Vec2 origin = Director::getInstance()->getVisibleOrigin();
    
    float cx = origin.x + visibleSize.width * 0.5;
    float cy = origin.y + visibleSize.height * 0.5;
    
    setPosition(cx, cy);
    
    //scheduleUpdate(); // Activate the update()
    //schedule(SEL_SCHEDULE(&MyDrawNode::myUpdate));
    //schedule(SEL_SCHEDULE(&MyDrawNode::myUpdate), 0.1);
    //schedule(SEL_SCHEDULE(&MyDrawNode::myUpdate), 0.1, 5, 1);
    //scheduleOnce(SEL_SCHEDULE(&MyDrawNode::myUpdate), 1);
    
    std::function<void(float)> myLambda = [this](float delta) {
        auto position = getPosition();  // Get the current position of self
        position.x += (50 * delta);     // Increase the current position
        setPosition(position);          // Set the position to the newly increased value
        auto rotation = getRotation();  // Get the current rotation of self
        rotation += 1;                  // Increase the current rotation
        setRotation(rotation);          // Set the rotation to the newly increased value
    };
    
    schedule(myLambda, "myLambda");
    
    /*
    schedule([this](float delta) {
        auto position = getPosition();  // Get the current position of self
        position.x += (50 * delta);     // Increase the current position
        setPosition(position);          // Set the position to the newly increased value
        auto rotation = getRotation();  // Get the current rotation of self
        rotation += 1;                  // Increase the current rotation
        setRotation(rotation);          // Set the rotation to the newly increased value
    }, "myLambda");
    */
    
    return true;
}


void MyDrawNode::draw(Renderer *renderer, const Mat4 &transform, uint32_t flags)
{
    if(!isDrawn)
    {
        auto draw = DrawNode::create();
        draw->drawLine(Vec2(-100, -100), Vec2(-100, +100), Color4F(1.0, 1.0, 1.0, 1.0));
        draw->drawLine(Vec2(+100, -100), Vec2(+100, +100), Color4F(1.0, 1.0, 1.0, 1.0));
        draw->drawLine(Vec2(-100, -100), Vec2(+100, -100), Color4F(1.0, 1.0, 1.0, 1.0));
        draw->drawLine(Vec2(-100, +100), Vec2(+100, +100), Color4F(1.0, 1.0, 1.0, 1.0));
        addChild(draw);
        isDrawn = true;
    }
}


void MyDrawNode::update(float delta)
{
    auto position = getPosition();  // Get the current position of self
    position.x += (50 * delta);     // Increase the current position
    setPosition(position);          // Set the position to the newly increased value
    auto rotation = getRotation();  // Get the current rotation of self
    rotation += 1;                  // Increase the current rotation
    setRotation(rotation);          // Set the rotation to the newly increased value
}


void MyDrawNode::myUpdate(float delta)
{
    auto position = getPosition();  // Get the current position of self
    position.x += (50 * delta);     // Increase the current position
    setPosition(position);          // Set the position to the newly increased value
    auto rotation = getRotation();  // Get the current rotation of self
    rotation += 1;                  // Increase the current rotation
    setRotation(rotation);          // Set the rotation to the newly increased value
}
